diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
index 492e99b17..3a1a5a151 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
@@ -4,7 +4,7 @@ import java.util.ArrayList;
 import java.util.List;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.TessellatorTerrain;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
@@ -86,16 +86,11 @@ public abstract class ChunkRenderer {
 
     public abstract boolean rebuild(boolean priority);
 
-    public boolean renderBlock(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull BlockModel<?> model, @NotNull TilePos tilePos) {
-        boolean rendered = false;
+    public boolean renderBlock(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull BlockModel<?> model, @NotNull TilePos tilePos) {
         tessellator.setLightmapCoord1i(LightmapHelper.getLightmapCoord(15, 15));
         tessellator.setColor4i(255, 255, 255, 255);
         tessellator.setTextureUV(0.0, 0.0);
-        rendered |= model.render(tessellator, worldSource, tilePos);
-        if (model.hasOverbright()) {
-            rendered |= model.renderOverbright(tessellator, worldSource, tilePos);
-        }
-        return rendered;
+        return model.render(tessellator, worldSource, tilePos);
     }
 
     public float distanceToEntitySquared(Entity entity) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java b/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java
index a76e31e04..622154ca5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java
@@ -11,7 +11,7 @@ import java.util.Set;
 import com.mojang.logging.CategorizedLogger;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.render.terrain.VertexBuffer.Entry;
-import net.minecraft.core.util.helper.Buffer;
+import org.lwjgl.BufferUtils;
 
 /**
  * 		Can render a lot of objects with a single call
@@ -36,8 +36,8 @@ public class RenderList {
 
     public RenderList(VertexBuffer vertexBuffer, int capacity) {
         this.vertexBuffer = vertexBuffer;
-        this.posBuffer = Buffer.createBuffer(capacity * 4).asIntBuffer();
-        this.sizeBuffer = Buffer.createBuffer(capacity * 4).asIntBuffer();
+        this.posBuffer = BufferUtils.createByteBuffer(capacity * 4).asIntBuffer();
+        this.sizeBuffer = BufferUtils.createByteBuffer(capacity * 4).asIntBuffer();
     }
 
     public void draw() {
@@ -155,7 +155,7 @@ public class RenderList {
 
             LOGGER.warn("Expanding RenderList IntBuffer from {} to {} ints...", buffer.capacity(), newCapacity);
 
-            return Buffer.createBuffer(newCapacity << 2).asIntBuffer();
+            return BufferUtils.createIntBuffer(newCapacity);
         }
         return buffer;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
index e1df10235..caf724961 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
@@ -96,7 +96,7 @@ public class TerrainRendererMultiDraw extends TerrainRenderer {
             if (renderList != null && renderList.size() > 0) {
                 GLRenderer.pushFrame();
                 GLRenderer.modelM4f().translate((float) ((region.posX << this.REGION_SIZE) - this.renderPosX), (float) -this.renderPosY, (float) ((region.posZ << this.REGION_SIZE) - this.renderPosZ));
-                GLRenderer.globalSetUniforms(Shaders.WORLD);
+                GLRenderer.globalSetUniforms(Shaders.TERRAIN);
 
                 renderList.draw();
                 this.drawCalls[0]++;
@@ -116,7 +116,7 @@ public class TerrainRendererMultiDraw extends TerrainRenderer {
             if (renderList != null && renderList.size() > 0) {
                 GLRenderer.pushFrame();
                 GLRenderer.modelM4f().translate((float) ((region.posX << this.REGION_SIZE) - this.renderPosX), (float) -this.renderPosY, (float) ((region.posZ << this.REGION_SIZE) - this.renderPosZ));
-                GLRenderer.globalSetUniforms(Shaders.WORLD);
+                GLRenderer.globalSetUniforms(Shaders.TERRAIN);
 
                 renderList.draw();
                 this.drawCalls[renderPass]++;
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexData.java b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexData.java
index 523b0f409..aa1c5408c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexData.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexData.java
@@ -2,7 +2,8 @@ package net.minecraft.client.render.terrain;
 
 import java.nio.ByteBuffer;
 
-import net.minecraft.core.util.helper.Buffer;
+import net.minecraft.client.util.helper.Buffer;
+import org.lwjgl.BufferUtils;
 
 public class VertexData {
 
@@ -13,6 +14,6 @@ public class VertexData {
     public int vertexCount;
 
     public VertexData(int size) {
-        this.buffer = Buffer.createBuffer(size);
+        this.buffer = BufferUtils.createByteBuffer(size);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/Tessellator.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/Tessellator.java
index da2d5ca78..fb1d12f89 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/Tessellator.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/Tessellator.java
@@ -1,8 +1,6 @@
 package net.minecraft.client.render.tessellator;
 
-import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.renderer.DrawMode;
-import net.minecraft.core.enums.EnumOS;
 import org.jetbrains.annotations.NotNull;
 
 public interface Tessellator {
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorGeneral.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorGeneral.java
index 1f51a346f..2820b27fc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorGeneral.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorGeneral.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.tessellator;
 
-public interface TessellatorGeneral extends TessellatorColor, TessellatorTextured, TessellatorLightmap, TessellatorNormal, TessellatorTerrain, Tessellator {
+public interface TessellatorGeneral extends TessellatorColor, TessellatorTextured, TessellatorLightmap, TessellatorNormal, Tessellator {
 
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticleShader.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticleShader.java
index 86b3f3c11..e75ac25cb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticleShader.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorParticleShader.java
@@ -5,9 +5,9 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.renderer.DrawMode;
 import net.minecraft.client.render.renderer.GLRenderer;
-import net.minecraft.core.util.helper.Buffer;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
+import org.lwjgl.BufferUtils;
 import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
@@ -31,7 +31,7 @@ public class TessellatorParticleShader implements TessellatorParticle {
     private double offsetZ;
 
     public TessellatorParticleShader(int size) {
-        this.buffer = Buffer.createBuffer(size);
+        this.buffer = BufferUtils.createByteBuffer(size);
         this.vao = GL41.glGenVertexArrays();
         this.vbo = GL41.glGenBuffers();
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
index 70f190ca4..eb328e0e7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
@@ -12,7 +12,7 @@ import org.lwjgl.BufferUtils;
 import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
-public class TessellatorTerrainImpl implements TessellatorTerrain {
+public class TessellatorTerrainImpl implements TessellatorGeneral {
 	private static final Logger LOGGER = LogUtils.getLogger();
 	public TerrainVertexData data;
 	public boolean drawing;
@@ -27,6 +27,10 @@ public class TessellatorTerrainImpl implements TessellatorTerrain {
 	private double offsetY;
 	private double offsetZ;
 
+	private byte normalX;
+	private byte normalY;
+	private byte normalZ;
+
 	private boolean lockedColor = false;
 	private int quadVertCount = 0;
 	
@@ -48,6 +52,7 @@ public class TessellatorTerrainImpl implements TessellatorTerrain {
 		setLightmapCoord1i(LightmapHelper.getLightmapCoord(15, 15));
 		setColor4i(255, 255, 255, 255);
 		setTextureUV(0.0, 0.0);
+		setNormal(0, 1, 0);
 
 		this.lockedColor = false;
         this.data.buffer.clear();
@@ -79,9 +84,14 @@ public class TessellatorTerrainImpl implements TessellatorTerrain {
         buffer.putFloat((float) this.textureU);
         buffer.putFloat((float) this.textureV);
 
-        buffer
-            .put((byte) ((LightmapHelper.getBlockLightFromCoord(this.lightmapCoord) << 4) + 7))
-            .put((byte) ((LightmapHelper.getSkyLightFromCoord(this.lightmapCoord) << 4) + 7));
+		buffer
+			.put((byte) ((LightmapHelper.getBlockLightFromCoord(this.lightmapCoord) << 4) + 7))
+			.put((byte) ((LightmapHelper.getSkyLightFromCoord(this.lightmapCoord) << 4) + 7));
+
+		buffer.put(this.normalX);
+		buffer.put(this.normalY);
+		buffer.put(this.normalZ);
+
 
 
         this.data.vertexCount++;
@@ -103,7 +113,7 @@ public class TessellatorTerrainImpl implements TessellatorTerrain {
 		if(this.data.buffer.capacity() < this.data.buffer.position() + size) {
 			int newSize = this.data.buffer.capacity() * 2;
 
-			LOGGER.info("Expanding {} Buffer ({} -> {})", "Entity Tessellator", this.data.buffer.capacity(), newSize);
+			LOGGER.info("Expanding {} Buffer ({} -> {})", "Terrain Tessellator", this.data.buffer.capacity(), newSize);
 
 			ByteBuffer newBuffer = BufferUtils.createByteBuffer(newSize);
 			this.data.buffer.flip();
@@ -169,6 +179,15 @@ public class TessellatorTerrainImpl implements TessellatorTerrain {
 		}
 	}
 
+	@Override
+	public void setNormal(float x, float y, float z) {
+		checkIsDrawing();
+
+		this.normalX = (byte) (x * 127.0f);
+		this.normalY = (byte) (y * 127.0f);
+		this.normalZ = (byte) (z * 127.0f);
+	}
+
 	public static class TerrainVertexData extends VertexData {
 
 		public TerrainVertexData(int size) {
@@ -194,13 +213,13 @@ public class TessellatorTerrainImpl implements TessellatorTerrain {
             GL41.glVertexAttribPointer(1, 4, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 4;    // Color
 			GL41.glVertexAttribPointer(2, 2, GL41.GL_FLOAT, false, vertexSize, offset); offset += 2 * Float.BYTES;    // UV
 			GL41.glVertexAttribPointer(3, 2, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 2;    // Lightmap
+			GL41.glVertexAttribPointer(4, 3, GL41.GL_BYTE, true, vertexSize, offset); offset += 3;    // Normals
 
 			GL41.glEnableVertexAttribArray(0);
 			GL41.glEnableVertexAttribArray(1);
 			GL41.glEnableVertexAttribArray(2);
 			GL41.glEnableVertexAttribArray(3);
-
-			GL41.glVertexAttrib3f(4, 0, -1, 0);
+			GL41.glEnableVertexAttribArray(4);
 		}
 
 		public void disable() {
@@ -218,6 +237,7 @@ public class TessellatorTerrainImpl implements TessellatorTerrain {
             size += 4;
             size += Float.BYTES * 2;
             size += 2;
+            size += 3;
 			return size;
 		}
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java b/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
index 40c29ed80..d97e8f693 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.texture;
 
-import static net.minecraft.core.util.helper.Buffer.buffer;
+import static net.minecraft.client.util.helper.Buffer.buffer;
 import static org.lwjgl.opengl.GL11.*;
 import static org.lwjgl.opengl.GL12.GL_CLAMP_TO_EDGE;
 import static org.lwjgl.opengl.GL12.GL_TEXTURE_MAX_LEVEL;
@@ -10,7 +10,7 @@ import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.enums.MipmapType;
 import net.minecraft.client.render.texture.meta.TextureProperties;
-import net.minecraft.core.util.helper.Buffer;
+import net.minecraft.client.util.helper.Buffer;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
@@ -44,8 +44,8 @@ public class Texture {
 		if(isGenerated()) {
 			return false;
 		}
-		
-		id = GLAllocation.generateTexture();
+
+        this.id = GLAllocation.generateTexture();
 		if(!isGenerated()) {
 			throw new RuntimeException("Texture not created!");
 		}
@@ -57,8 +57,8 @@ public class Texture {
 		if(!isGenerated()) {
 			return false;
 		}
-		GLAllocation.deleteTexture(id);
-		id = 0;
+		GLAllocation.deleteTexture(this.id);
+        this.id = 0;
 		return true;
 	}
 	
@@ -67,7 +67,7 @@ public class Texture {
 			return false;
 		}
 		
-		glBindTexture(GL_TEXTURE_2D, id);
+		glBindTexture(GL_TEXTURE_2D, this.id);
 		return true;
 	}
 
@@ -83,7 +83,7 @@ public class Texture {
 //	}
 
 	public boolean isGenerated() {
-		return id != 0;
+		return this.id != 0;
 	}
 	
 	public int getWidth() {
@@ -95,7 +95,7 @@ public class Texture {
 	}
 	
 	public int id() {
-		return id;
+		return this.id;
 	}
 
 
@@ -115,8 +115,6 @@ public class Texture {
 	public void setupTexture(BufferedImage img, boolean blurTexture, boolean clampTexture, boolean mipmap) {
 		bind();
 
-
-
 		if(blurTexture) {
 			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
 			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
@@ -225,9 +223,9 @@ public class Texture {
 						int y1 = y << 1;
 
 						if(smooth) {
-							int color0 = data[previousWidth * (y1 + 0) + (x1 + 0)];
-							int color1 = data[previousWidth * (y1 + 0) + (x1 + 1)];
-							int color2 = data[previousWidth * (y1 + 1) + (x1 + 0)];
+							int color0 = data[previousWidth * (y1) + (x1)];
+							int color1 = data[previousWidth * (y1) + (x1 + 1)];
+							int color2 = data[previousWidth * (y1 + 1) + (x1)];
 							int color3 = data[previousWidth * (y1 + 1) + (x1 + 1)];
 
 							color = blendColor(blendColor(color0, color1), blendColor(color2, color3));
